

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red


extern int    FasterMode      = 1; //0=sma, 1=ema, 2=smma, 3=lwma
extern int    FasterMA        = 5;
extern int    SlowerMode      = 1; //0=sma, 1=ema, 2=smma, 3=lwma
extern int    SlowerMA        = 5;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   IndicatorBuffers(3);   
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDn);
   SetIndexBuffer(2, trend);
//----
   return(0);
  }

int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
       
      double fasterMAnow = iMA(NULL, 0, FasterMA, 0, FasterMode, PRICE_CLOSE,i);
      double slowerMAnow = iMA(NULL, 0, SlowerMA, 0, SlowerMode, PRICE_OPEN, i);
      trend[i] = trend[i+1];
      
      if (fasterMAnow > slowerMAnow) trend[i] = 1;
      if (fasterMAnow < slowerMAnow) trend[i] =-1; 
      
      //
      //
      //
      //
      //
      
      CrossUp[i] = EMPTY_VALUE;
      CrossDn[i] = EMPTY_VALUE;
      if (trend[i] !=trend[i+1])
      if (trend[i] == 1)
            CrossUp[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
      else  CrossDn[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
      }
         
      //
      //
      //
      //
      //
         
      if (alertsOn)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
      }
   
return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MA_Cross_OC ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MA_Cross_OC "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

